Commit a8656614 authored by Ian Rogers's avatar Ian Rogers Committed by Arnaldo Carvalho de Melo

perf test: Expand pipe/inject test

Test recording of call-graphs and injecting --build-all. Add/expand
trap handler.
Signed-off-by: default avatarIan Rogers <irogers@google.com>
Cc: Adrian Hunter <adrian.hunter@intel.com>
Cc: Alexander Shishkin <alexander.shishkin@linux.intel.com>
Cc: Anne Macedo <retpolanne@posteo.net>
Cc: Arnd Bergmann <arnd@arndb.de>
Cc: Athira Rajeev <atrajeev@linux.vnet.ibm.com>
Cc: Casey Chen <cachen@purestorage.com>
Cc: Chaitanya S Prakash <chaitanyas.prakash@arm.com>
Cc: Colin Ian King <colin.i.king@gmail.com>
Cc: Dominique Martinet <asmadeus@codewreck.org>
Cc: Ingo Molnar <mingo@redhat.com>
Cc: James Clark <james.clark@linaro.org>
Cc: Jann Horn <jannh@google.com>
Cc: Jiri Olsa <jolsa@kernel.org>
Cc: Kan Liang <kan.liang@linux.intel.com>
Cc: Mark Rutland <mark.rutland@arm.com>
Cc: Masahiro Yamada <masahiroy@kernel.org>
Cc: Namhyung Kim <namhyung@kernel.org>
Cc: Peter Zijlstra <peterz@infradead.org>
Cc: Sun Haiyong <sunhaiyong@loongson.cn>
Cc: Weilin Wang <weilin.wang@intel.com>
Cc: Yang Jihong <yangjihong1@huawei.com>
Cc: Yunseong Kim <yskelg@gmail.com>
Cc: Ze Gao <zegao2021@gmail.com>
Link: https://lore.kernel.org/r/20240817064442.2152089-7-irogers@google.comSigned-off-by: default avatarArnaldo Carvalho de Melo <acme@redhat.com>
parent 63c89dc5
#!/bin/sh
#!/bin/bash
# perf pipe recording and injection test
# SPDX-License-Identifier: GPL-2.0
......@@ -12,30 +12,87 @@ skip_test_missing_symbol ${sym}
data=$(mktemp /tmp/perf.data.XXXXXX)
prog="perf test -w noploop"
task="perf"
err=0
if ! perf record -e task-clock:u -o - ${prog} | perf report -i - --task | grep ${task}; then
echo "cannot find the test file in the perf report"
exit 1
fi
set -e
if ! perf record -e task-clock:u -o - ${prog} | perf inject -b | perf report -i - | grep ${sym}; then
echo "cannot find noploop function in pipe #1"
exit 1
fi
cleanup() {
rm -rf "${data}"
rm -rf "${data}".old
perf record -e task-clock:u -o - ${prog} | perf inject -b -o ${data}
if ! perf report -i ${data} | grep ${sym}; then
echo "cannot find noploop function in pipe #2"
exit 1
fi
trap - EXIT TERM INT
}
perf record -e task-clock:u -o ${data} ${prog}
if ! perf inject -b -i ${data} | perf report -i - | grep ${sym}; then
echo "cannot find noploop function in pipe #3"
exit 1
fi
trap_cleanup() {
echo "Unexpected signal in ${FUNCNAME[1]}"
cleanup
exit 1
}
trap trap_cleanup EXIT TERM INT
test_record_report() {
echo
echo "Record+report pipe test"
task="perf"
if ! perf record -e task-clock:u -o - ${prog} | perf report -i - --task | grep -q ${task}
then
echo "Record+report pipe test [Failed - cannot find the test file in the perf report #1]"
err=1
return
fi
if ! perf record -g -e task-clock:u -o - ${prog} | perf report -i - --task | grep -q ${task}
then
echo "Record+report pipe test [Failed - cannot find the test file in the perf report #2]"
err=1
return
fi
echo "Record+report pipe test [Success]"
}
test_inject_bids() {
inject_opt=$1
echo
echo "Inject ${inject_opt} build-ids test"
if ! perf record -e task-clock:u -o - ${prog} | perf inject ${inject_opt}| perf report -i - | grep -q ${sym}
then
echo "Inject build-ids test [Failed - cannot find noploop function in pipe #1]"
err=1
return
fi
if ! perf record -g -e task-clock:u -o - ${prog} | perf inject ${inject_opt} | perf report -i - | grep -q ${sym}
then
echo "Inject ${inject_opt} build-ids test [Failed - cannot find noploop function in pipe #2]"
err=1
return
fi
perf record -e task-clock:u -o - ${prog} | perf inject ${inject_opt} -o ${data}
if ! perf report -i ${data} | grep -q ${sym}; then
echo "Inject ${inject_opt} build-ids test [Failed - cannot find noploop function in pipe #3]"
err=1
return
fi
perf record -e task-clock:u -o ${data} ${prog}
if ! perf inject ${inject_opt} -i ${data} | perf report -i - | grep -q ${sym}; then
echo "Inject ${inject_opt} build-ids test [Failed - cannot find noploop function in pipe #4]"
err=1
return
fi
echo "Inject ${inject_opt} build-ids test [Success]"
}
test_record_report
test_inject_bids -b
test_inject_bids --buildid-all
cleanup
exit $err
rm -f ${data} ${data}.old
exit 0
Markdown is supported
0%
or
You are about to add 0 people to the discussion. Proceed with caution.
Finish editing this message first!
Please register or to comment